/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2002 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2002.12.10	SDKްޮ
//
// DateEx.cpp	CDateEx NX̓̒`܂D
// ̃NX͓ti{jň߂̃NXłD
//
//////////////////////////////////////////////////////////////////////////////


#include "DateEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-------------------------------------------------------------------------*/
// CDateEx		NX̃RXgN^
/*-------------------------------------------------------------------------*/
// yy,mm,dd IuWFNg쐬
CDateEx::CDateEx(
	INT inYY,
	INT inMM,
	INT inDD)
{	
	// NXϐ
	Initial();
	// YMD `FbNIuWFNg
	SyncVariable(inYY,inMM,inDD);
}

// VAf[gIuWFNg쐬
CDateEx::CDateEx(
	LONG inJullanSerial)
{
	// NXϐ
	Initial();
	// VA`FbN
	if (inJullanSerial >= 0)	{
		m_JullanSerial = inJullanSerial;
		SyncVariable();
	}
}

// ̓tIuWFNg쐬
CDateEx::CDateEx(
	CHAR* inYmd,
	INT inYPos,
	INT inMPos,
	INT inDPos)
{
	// NXϐ
	Initial();
	// `FbN
	INT	theYmdLen = strlen(inYmd);
	if ((theYmdLen >= 8)			&&
		(theYmdLen >= (inYPos+4))	&&	
		(theYmdLen >= (inMPos+2))	&&
		(theYmdLen >= (inDPos+2)) )		{
		CHAR	theYYStr[5];
		CHAR	theMMStr[3];
		CHAR	theDDStr[3];
		memcpy(theYYStr,inYmd+inYPos,4);theYYStr[4] = 0x0;
		memcpy(theMMStr,inYmd+inMPos,2);theMMStr[2] = 0x0;
		memcpy(theDDStr,inYmd+inDPos,2);theDDStr[2] = 0x0;
		SyncVariable(atoi(theYYStr),
					 atoi(theMMStr),
					 atoi(theDDStr) );
	}
}

// NXϐ
void
CDateEx::Initial()
{
	m_yy = 0;
	m_mm = 0;
	m_dd = 0;
	m_JullanSerial = -1;
	m_youbi = -1;
}

/*-------------------------------------------------------------------------*/
// CDateEx		NX̃fXgN^
/*-------------------------------------------------------------------------*/
CDateEx::~CDateEx()
{
}

/*-------------------------------------------------------------------------*/
// Ymd2JullanSerial		yyyy.mm.dd  VAf[g			static
/*-------------------------------------------------------------------------*/
LONG
CDateEx::Ymd2JullanSerial(	
	INT inYY,
	INT inMM,
	INT inDD)
{
	INT	i;
	LONG	theDayCount;
	
	// ܂NZiON܂Łj
	theDayCount = (inYY-1) * 365;
	for(i=1;i<inYY;i++)	{
		// [N͂PZ
		if(isLeapYear(i))	theDayCount++;
	}
	// ɌZiO܂Łj
	for(i=1;i<inMM;i++)	{
		theDayCount += LastDay(inYY,i);
	}
	// ŌɓZij
	return (theDayCount + inDD);				
}

/*-------------------------------------------------------------------------*/
// JullanSerial2Ymd		VAf[g  yyyy.mm.dd			static
/*-------------------------------------------------------------------------*/
void
CDateEx::JullanSerial2Ymd(	
	LONG inJullanSerial,
	INT* outYY,
	INT* outMM,
	INT* outDD)
{
	LONG	theJSerialRemnant;	// c
	LONG	theDayCount;		// ̃JE^

	// NZĂΏۂƂȂN߂
	INT	theYY = 1;
	INT	theAddYear;
	theDayCount = 0;
	theJSerialRemnant = inJullanSerial;
	for (;;)	{
		// N̓Zi[Ń{Pj
		theAddYear = 365;
		if(isLeapYear(theYY))	theAddYear++;
		theDayCount += theAddYear;
		// Zc𒴂Nm
		if (theJSerialRemnant <= theDayCount)	break;
		// ̔N
		theYY++;
	}
	*outYY = theYY;

	// c̓𗘗p߂
	INT	theMM = 1;
	INT	theAddMonth;
	theJSerialRemnant = inJullanSerial - (theDayCount - theAddYear);
	theDayCount = 0;
	for (;;)	{
		// ̓Z
		theAddMonth = LastDay(theYY,theMM);
		theDayCount += theAddMonth;
		// Zc𒴂猎m
		if (theJSerialRemnant <= theDayCount)	break;
		// ̌
		theMM++;
	}
	*outMM = theMM;

	// c̓ɂȂ
	*outDD = theJSerialRemnant - (theDayCount - theAddMonth);
}

/*-------------------------------------------------------------------------*/
// SyncVariable			NXϐ𓯊						protected
/*-------------------------------------------------------------------------*/
void
CDateEx::SyncVariable()
{
	// m_JullanSerial ɂ킹ăNXϐ𓯊
	JullanSerial2Ymd(m_JullanSerial,&m_yy,&m_mm,&m_dd);
	m_youbi = JullanSerial2Youbi(m_JullanSerial);	
}

/*-------------------------------------------------------------------------*/
// SyncVariable			NXϐ𓯊						protected
/*-------------------------------------------------------------------------*/
void
CDateEx::SyncVariable(
	INT inYY,
	INT inMM,
	INT inDD)
{
	// inYY,inMM,inDD ɂ킹ăNXϐ𓯊
	// t`FbN
	if ((inYY >= 1)					&&
		(inMM >= 1 && inMM <= 12)	&&
		(inDD >= 1 && inDD <= LastDay(inYY,inMM)) )	{
		m_yy = inYY;
		m_mm = inMM;
		m_dd = inDD;
		m_JullanSerial = Ymd2JullanSerial(inYY,inMM,inDD);
		m_youbi = JullanSerial2Youbi(m_JullanSerial);
	}
	else	{
		// NXϐNA
		Initial();
	}
}

/*-------------------------------------------------------------------------*/
// youbiStr				jo					static
/*-------------------------------------------------------------------------*/
CHAR*
CDateEx::GetYoubiStr(
	INT		inYoubi,
	CHAR *	outYoubiStr)
{
	switch (inYoubi)	{
		case SUN:	
			strcpy(outYoubiStr,"");	break;
		case MON:	
			strcpy(outYoubiStr,"");	break;
		case TUE:	
			strcpy(outYoubiStr,"");	break;
		case WEN:	
			strcpy(outYoubiStr,"");	break;
		case THU:	
			strcpy(outYoubiStr,"");	break;
		case FRI:	
			strcpy(outYoubiStr,"");	break;
		case SAT:	
			strcpy(outYoubiStr,"y");	break;
		default:
			strcpy(outYoubiStr,"H");	break;
	}
	return outYoubiStr;
}

/*-------------------------------------------------------------------------*/
// youbiStr				jo					public
/*-------------------------------------------------------------------------*/
CHAR*
CDateEx::youbiStr(
	CHAR * outYoubiStr)
{
	// \[X玝Ă悤ȂƂv񂾂ǃAv̊Ǘʓ|
	// ɂȂŒڏĂ܂BCɓȂ΃TuNXŃI[o
	// [ChĂˁI

	return GetYoubiStr(m_youbi,outYoubiStr);
}

/*-------------------------------------------------------------------------*/
// Format				 tH[}bgďo					public
/*-------------------------------------------------------------------------*/
CHAR*
CDateEx::Format(
	CHAR *	outYmd,
	INT		inFormatNo,
	BOOL	inZero,
	CHAR	inSeparate)
{
	// Ƃ肠KvȂ̂̂ݎĂ̂ŁAق̃tH[}bgŏo
	// Ƃ̓TuNX쐬ăI[o[ChĂˁI

	CHAR	theYoubiStr[3];		// j񃏁[N

	switch (inFormatNo)	{
		case yymmdd:				// YYMMDD
			sprintf(outYmd,"%2.2d%2.2d%2.2d",(m_yy % 100),m_mm,m_dd);
			break;
		case yyyy_mm_dd:			// yyyy/mm/dd
			if (inZero)
				sprintf(outYmd,"%4.4d%c%2.2d%c%2.2d",
							m_yy,inSeparate,m_mm,inSeparate,m_dd);
			else
				sprintf(outYmd,"%4.4d%c%d%c%d",
							m_yy,inSeparate,m_mm,inSeparate,m_dd);
			break;
		case yy_mm_dd:				// yy/mm/dd
			if (inZero)
				sprintf(outYmd,"%2.2d%c%2.2d%c%2.2d",
							(m_yy % 100),inSeparate,m_mm,inSeparate,m_dd);
			else
				sprintf(outYmd,"%2.2d%c%d%c%d",
							(m_yy % 100),inSeparate,m_mm,inSeparate,m_dd);
			break;
		case Jyyyy_mm_dd:			// yyyyNmmdd
			if (inZero)
				sprintf(outYmd,"%4.4dN%2.2d%2.2d",
							m_yy,m_mm,m_dd);
			else
				sprintf(outYmd,"%4.4dN%d%d",
							m_yy,m_mm,m_dd);
			break;
		case Jyyyy_mm_ddw:			// yyyyNmmdd[j]
			if (inZero)
				sprintf(outYmd,"%4.4dN%2.2d%2.2d(%s)",
							m_yy,m_mm,m_dd,youbiStr(theYoubiStr));
			else
				sprintf(outYmd,"%4.4dN%d%d(%s)",
							m_yy,m_mm,m_dd,youbiStr(theYoubiStr));
			break;
		case Jyyyy_mm_ddw_n:		// yyyyNmmdd[xj]
			if (inZero)
				sprintf(outYmd,"%4.4dN%2.2d%2.2d[%d%sj]",
							m_yy,m_mm,m_dd,NoOfWeek(),youbiStr(theYoubiStr));
			else
				sprintf(outYmd,"%4.4dN%d%d[%d%sj]",
							m_yy,m_mm,m_dd,NoOfWeek(),youbiStr(theYoubiStr));
			break;
		case Jyy_mm_dd:				// yyNmmdd
			if (inZero)
				sprintf(outYmd,"%2.2dN%2.2d%2.2d",
							(m_yy % 100),m_mm,m_dd);
			else
				sprintf(outYmd,"%2.2dN%d%d",
							(m_yy % 100),m_mm,m_dd);
			break;
		case Jyy_mm_ddw:			// yyNmmdd[j]
			if (inZero)
				sprintf(outYmd,"%2.2dN%2.2d%2.2d(%s)",
							(m_yy % 100),m_mm,m_dd,youbiStr(theYoubiStr));
			else
				sprintf(outYmd,"%2.2dN%d%d(%s)",
							(m_yy % 100),m_mm,m_dd,youbiStr(theYoubiStr));
			break;
		case Jyy_mm_ddw_n:			// yyNmmdd[xj]
			if (inZero)
				sprintf(outYmd,"%2.2dN%2.2d%2.2d[%d%sj]",
							(m_yy % 100),m_mm,m_dd,NoOfWeek(),youbiStr(theYoubiStr));
			else
				sprintf(outYmd,"%2.2dN%d%d[%d%sj]",
							(m_yy % 100),m_mm,m_dd,NoOfWeek(),youbiStr(theYoubiStr));
			break;
		case Jyy_mm:				// yyNmm
			if (inZero)
				sprintf(outYmd,"%2.2dN%2.2d",
							(m_yy % 100),m_mm);
			else
				sprintf(outYmd,"%2.2dN%d",
							(m_yy % 100),m_mm);
			break;
		default:					// YYYYMMDD
			sprintf(outYmd,"%4.4d%2.2d%2.2d",m_yy,m_mm,m_dd);
			break;
	}

	return outYmd;
}

/*-------------------------------------------------------------------------*/
// Holiday				jՓǂ`FbNi0>:jՓ)		public
/*-------------------------------------------------------------------------*/
INT
CDateEx::Holiday()
{
	// Wpj[YdlȂŁA̍ɑΉ΃TuNX쐬
	// I[o[ChĂˁI

	// 99.6.11 nbs[}f[ɑΉ

	INT	result = 0;

	// ͖ʓ|ȂŌvZȂ CDATEEX_STARTYY ` CDATEEX_ENDYY
	// ͈̔͂ŒڃR[fBOĂ܂BȊO͉LftHg
	// ȂŐmł͂܂B
	INT	syunbunDD = 21;		// t̓
	INT	syuubunDD = 23;		// H̓

	switch (m_mm)	{
		case 1:
			if (m_dd == 1)		result =  1;	// U
			if (m_yy < 2000)	{
				if (m_dd == 15) 	result =  2;	// l̓
			}
			else {
				if (m_dd > 7)	{
					// 2000Nnbs[}f[ƂȂ̂ő񌎗jl̓
					CDateEx theYmd(m_yy,m_mm,1);
					while (theYmd.youbi() != MON)	theYmd++;
					theYmd += 7;
					if (theYmd.day() == m_dd)	result =  2;	// l̓
				}
			}
			break;
		case 2:
			if (m_dd == 11)		result =  3;	// LO
			break;
		case 3:
			/* t̓ */
			switch (m_yy)	{
				case 1996: case 1997: case 2000: case 2001:
				case 2004: case 2005: case 2008:
				case 2009: case 2012: case 2013: case 2016:
				case 2017: case 2020: case 2021: case 2024:
				case 2025: case 2026: case 2028: case 2039:
				case 2030: case 2032: case 2033: case 2036:
				case 2037: case 2038: case 2040: case 2041:
				case 2042: case 2044: case 2045: case 2046:
				case 2048: case 2049: case 2050:
					syunbunDD = 20;
					break;
				case 2034:
					syunbunDD = 23;
					break;
			}
			if (m_dd == syunbunDD)	result =  4;// t̓
			break;
		case 4:
			if (m_dd == 29)		result =  5;	// ݂ǂ̓
			break;
		case 5:
			if (m_dd == 3)		result =  6;	// @LO
			if (m_dd == 4) 		result =  7;	// ̋x
			if (m_dd == 5) 		result =  8;	// ǂ̓
			break;
		case 7:
			if (m_dd == 20)		result =  15;	// C̓
			break;
		case 9:
			if (m_dd == 15)		result =  9;	// hV̓
			switch (m_yy)	{
				case 2012: case 2016: case 2020: case 2024:
				case 2028: case 2032: case 2036: case 2040:
				case 2044: case 2045: case 2048: case 2049:
					syuubunDD = 22;
					break;
			}
			if (m_dd == syuubunDD)	result =  10;// H̓
			break;
		case 10:
			if (m_yy < 2000)	{
				if (m_dd == 10)		result =  11;	// ̈̓
			}
			else {
				if (m_dd > 7)	{
					// 2000Nnbs[}f[ƂȂ̂ő񌎗jl̓
					CDateEx theYmd(m_yy,m_mm,1);
					while (theYmd.youbi() != MON)	theYmd++;
					theYmd += 7;
					if (theYmd.day() == m_dd)	result =  11;	// ̈̓
				}
			}
			break;
		case 11:
			if (m_dd == 3)		result =  12;	// ̓
			if (m_dd == 23) 	result =  13;	// ΘJӂ̓
			break;
		case 12:
			if (m_dd == 23) 	result =  14;	// Vca
			break;
			break;
	}
	return result;
}

/*-------------------------------------------------------------------------*/
// HolidayStr			jՓo					public
/*-------------------------------------------------------------------------*/
CHAR *
CDateEx::HolidayStr(
	CHAR * outHolidayStr)
{
	// \[X玝Ă悤ȂƂv񂾂ǃAv̊Ǘʓ|
	// ɂȂŒڏĂ܂BCɓȂ΃TuNXŃI[o
	// [ChĂˁIi̍ɑΉƂj

	switch (Holiday())	{
		case 1:		// U
			strcpy(outHolidayStr,"U");			break;
		case 2:		// l̓
			strcpy(outHolidayStr,"l̓");		break;
		case 3:		// LO
			strcpy(outHolidayStr,"LO");		break;
		case 4:		// t̓
			strcpy(outHolidayStr,"t̓");		break;
		case 5:		// ݂ǂ̓
			strcpy(outHolidayStr,"݂ǂ̓");		break;
		case 6:		// @LO
			strcpy(outHolidayStr,"@LO");		break;
		case 7:		// ̋x
			strcpy(outHolidayStr,"̋x");		break;
		case 8:		// ǂ̓
			strcpy(outHolidayStr,"ǂ̓");		break;
		case 9:		// hV̓
			strcpy(outHolidayStr,"hV̓");		break;
		case 10:	// H̓
			strcpy(outHolidayStr,"H̓");		break;
		case 11:	// ̈̓
			strcpy(outHolidayStr,"̈̓");		break;
		case 12:	// ̓
			strcpy(outHolidayStr,"̓");		break;
		case 13:	// ΘJӂ̓
			strcpy(outHolidayStr,"ΘJӂ̓");	break;
		case 14:	// Vca
			strcpy(outHolidayStr,"Vca");		break;
		case 15:	// C̓
			strcpy(outHolidayStr,"C̓");			break;
		default:	// 
			strcpy(outHolidayStr,"");	break;
	}
	return outHolidayStr;
}

/*-------------------------------------------------------------------------*/
// Between				FromTo ͈̔͂Ɂi܂ށjɂ		public
/*-------------------------------------------------------------------------*/
BOOL
CDateEx::Between(
	CDateEx & inFromDate,
	CDateEx & inToDate)
{
	return ( (m_JullanSerial >= inFromDate.JullanSerial())	&&
			 (m_JullanSerial <= inToDate.JullanSerial()) );
}

/*-------------------------------------------------------------------------*/
// DoFurikae			xUւ							public
/*-------------------------------------------------------------------------*/
BOOL
CDateEx::DoFurikae(
	INT	inMode,
	BOOL	isSatDayToCntain)
{
	INT	theFurikaeDayCount = 0;			// Uւ
	INT	theYoubi = m_youbi;
	CDateEx	theNewYMD(m_JullanSerial);

	switch (inMode)	{

		case Hday_PreviousDay:				// x̏ꍇ͑O

			if (isSatDayToCntain)
				theFurikaeDayCount = 2;
			else
				theFurikaeDayCount = 1;
			if (theYoubi == MON)	{		// j̏ꍇ͐U֋x`FbN
				CDateEx	theBackYMD(m_JullanSerial-1);
				if (theBackYMD.Holiday())	{
					theNewYMD--;
					theYoubi = SUN;			// U֋x̏ꍇ͈Uj
				}
			}
			if (theYoubi == SUN)	{
				// j̏ꍇ͓yjx̏ꍇ͋jłȂꍇ͓yj
				theNewYMD -= theFurikaeDayCount;
			}
			else if (theYoubi == SAT && isSatDayToCntain)	{
				// yj̏ꍇ͋jɁiyjx̏ꍇj
				theNewYMD--;
			}
			// jՓłȂ̂ڂĒT
			while (theNewYMD.Holiday())	{
				theNewYMD--;		// U֓j̏ꍇXɂPO
				if (theNewYMD.youbi() == SUN)	{
					// j̏ꍇ͓yjx̏ꍇ͋jłȂꍇ͓yj
					theNewYMD -= theFurikaeDayCount;
				}
				else if (theNewYMD.youbi() == SAT && isSatDayToCntain)	{
					// yj̏ꍇ͋jɁiyjx̏ꍇj
					theNewYMD--;	
				}
			}
			break;

		case Hday_NextDay:					// x̏ꍇ͎̓

			if (theYoubi == MON)	{		// j̏ꍇ͐U֋x`FbN
				CDateEx	theBackYMD(m_JullanSerial-1);
				if (theBackYMD.Holiday())	{
					theNewYMD++;
					theYoubi = TUE;			// U֋x̏ꍇ͉Ηj
				}
			}
			if (theYoubi == SAT && isSatDayToCntain)	{
				theNewYMD++;
				theYoubi = SUN;				// yjx̏ꍇ͓jiU֋x`FbN̂߁j
			}
			if (theYoubi == SUN)	{
				if (theNewYMD.Holiday())
					theNewYMD += 2;			// jōՓ̏ꍇ͂Qi߂ĉΗj
				else	
					theNewYMD++;			// j̏ꍇ͌j
			}
			while (theNewYMD.Holiday())	{
				theNewYMD ++;				// U֓j̏ꍇXɂP
				if (theNewYMD.youbi() == SAT && isSatDayToCntain)	{
					theNewYMD++;
					theYoubi = SUN;			// yjx̏ꍇ͓jiU֋x`FbN̂߁j
				}
				if (theYoubi == SUN)	{
					if (theNewYMD.Holiday())
						theNewYMD += 2;		// jōՓ̏ꍇ͂Qi߂ĉΗj
					else	
						theNewYMD++;		// j̏ꍇ͌j
				}
			}
			break;
	}

	// Uւ`FbN
	BOOL	result = FALSE;
	if (m_JullanSerial != theNewYMD.JullanSerial())	{
		// UւĂ
		m_JullanSerial = theNewYMD.JullanSerial();
		SyncVariable();
		result = TRUE;
	}

	return result;
}

/*-------------------------------------------------------------------------*/
// DoNextMonth			Ɂȉꍇ͕␳j			public
/*-------------------------------------------------------------------------*/
void
CDateEx::DoNextMonth()
{
	INT	theYY = m_yy;
	INT	theMM = m_mm;
	INT	theDD = m_dd;
	theMM++;
	if (theMM > 12)	{
		theYY++;
		theMM = 1;
	}
	theDD = __min(theDD,LastDay(theYY,theMM));
	SyncVariable(theYY,theMM,theDD);
}

/*-------------------------------------------------------------------------*/
// DoBackMonth			OɁȉꍇ͕␳j			public
/*-------------------------------------------------------------------------*/
void
CDateEx::DoBackMonth()
{
	INT	theYY = m_yy;
	INT	theMM = m_mm;
	INT	theDD = m_dd;
	theMM--;
	if (theMM < 1)	{
		theYY--;
		theMM = 12;
	}
	theDD = __min(theDD,LastDay(theYY,theMM));
	SyncVariable(theYY,theMM,theDD);
}

/*-------------------------------------------------------------------------*/
// DoNextYear			NɁȉꍇ͕␳j			public
/*-------------------------------------------------------------------------*/
void
CDateEx::DoNextYear()
{
	INT	theYY = m_yy;
	INT	theMM = m_mm;
	INT	theDD = m_dd;
	theYY++;
	if (theYY > 9999)	{
		theYY = 9999;
	}
	theDD = __min(theDD,LastDay(theYY,theMM));
	SyncVariable(theYY,theMM,theDD);
}

/*-------------------------------------------------------------------------*/
// DoBackYear			ONɁȉꍇ͕␳j			public
/*-------------------------------------------------------------------------*/
void
CDateEx::DoBackYear()
{
	INT	theYY = m_yy;
	INT	theMM = m_mm;
	INT	theDD = m_dd;
	theYY--;
	if (theYY < 1)	{
		theYY = 1;
	}
	theDD = __min(theDD,LastDay(theYY,theMM));
	SyncVariable(theYY,theMM,theDD);
}

/*-------------------------------------------------------------------------*/
// GotoFirstDay												public
/*-------------------------------------------------------------------------*/
void
CDateEx::GotoFirstDay()
{
	INT	theYY = m_yy;
	INT	theMM = m_mm;
	INT	theDD = 1;
	SyncVariable(theYY,theMM,theDD);
}

/*-------------------------------------------------------------------------*/
// GotoLastDay												public
/*-------------------------------------------------------------------------*/
void
CDateEx::GotoLastDay()
{
	INT	theYY = m_yy;
	INT	theMM = m_mm;
	INT	theDD = thisLastDay();
	SyncVariable(theYY,theMM,theDD);
}
